#!/usr/bin/env python
#-*-coding: utf-8-*-
import pickle

class Brands():
    def __init__(self):
        self.get_brands()
    def get_brands(self):
        self.brands = load_file('brands')
    def __getitem__(self, i):
        return self.brands[i]
    def __len__(self):
        return len(self.brands)

class Names():
    def __init__(self, brandnumber):
        self.set_brandnumber(brandnumber)
        self.get_names()
    def set_brandnumber(self, data):
        self.brandnumber = data
    def get_names(self):
        try:
            print self.brandnumber
            self.names = load_file(self.brandnumber)
        except:
            print 'Wlasna nazwa towarzystwa'
            self.names = 'Wlasna nazwa towarzystwa'
    def __getitem__(self, i):
        return self.names[i]
    def __len__(self):
        return len(self.names)

class Name():
    def __init__(self, fundnumber=0):
        self.setfundnumber(fundnumber)
    def setfundnumber(self,number):
        self.fundnumber=number
        self.getbrandnumber()#automatyczna aktualizacja nr towarzystwa
    def getbrandnumber(self):
        fn = self.fundnumber
        if fn == 0:
            self.brandnumber=0
        elif fn>1000:
            self.brandnumber = int(str(fn)[-3:len(str(fn))])
        else:
            self.brandnumber=0
        return self.brandnumber
    def getfundname(self):
        if self.brandnumber == 0:
            self.fundname = 'Brak nazwy funduszu'
            return self.fundname
        else:
            a = load_file(self.brandnumber)
            for i in a:
                if i[0] == self.fundnumber:
                    self.fundname = i[1]
                    return self.fundname
            self.fundname = 'Brak nazwy funduszu'
            return self.fundname
    def getbrandname(self):
        if self.brandnumber == 0:
            self.fundname = 'Brak nazwy towrzystwa'
            return self.brandname
        else:
            a = load_file('brands')
            for i in a:
                if i[0] == self.brandnumber:
                    self.brandname = i[1]
                    return self.brandname
            self.brandname = 'Brak nazwy towarzystwa'
            return self.brandname
        

def get_brand():
    #zwraca [numer_tow,'nazwa tow']
    b = Brands()
    print 'Wybierz towarzystwo:'
    for i in range(len(b.brands)):
        print '%s. %s(%s)' % (i+1,b.brands[i][1],b.brands[i][0])
    bch = get_menu_choice(i+1)
    return b[bch-1]
    
def get_name(brandnumber):
    #zwraca [numer_fund,'nazwa fund']
    n = Names(brandnumber)
    print 'Wybierz fundusz:'
    for i in range(len(n.names)):
        print '%s. %s(%s)' % (i+1,n.names[i][1],n.names[i][0])
    nch = get_menu_choice(i+1)
    return n[nch-1]


def save_file(brand, my, path='./classes/'):
    f = open(path+brand+'.txt', 'w')
   
    pickle.dump(my, f)
    f.close()
    print 'Zapisano %s rejestrów' % len(my)

def load_file(brand,path='./classes/'):
    f = open(path+str(brand)+'.txt', 'r')
    n = []
    n = pickle.load(f)
    f.close()
    return n
    
    
def get_menu_choice(number = 8):
    while True:
        a = raw_input("Twój wybór:")
        try:
            a = int(a)
        except:
            print "To nie jest liczba!!!"
            print_menu()
            continue
        if 0 < a <= number:
            return a
        else:
            print "Liczba nie jest z przedzialu (1 do %s)" % number
            print_menu()
